import es, path, sqlite3, playerlib, popuplib, langlib
scfg = __import__('life_insurance.RuntimeConfiguration',fromlist=['life_insurance'],level=0)

info = es.AddonInfo()
info.version                 = '1.1.0'      # Version of this script
info.author                  = 'Ojii'       # The author of this script
info.bbank                   = '5.3b'       # BBank version compatible with this script
info.ba_bank                 = '2.5.6 BETA' # ba_bank version compatible with this script
info.french_translation_help = 'DoCky'      # Merci bien!
es.ServerVar('life_insurance_ver',info.version).makepublic()

gamedir = path.path(str(es.ServerVar('eventscripts_gamedir')))
interfacedir = gamedir.joinpath('addons/eventscripts/life_insurance/bank_interfaces/')
allguns = ('hegrenade','flashbang','smokegrenade','glock','usp','p228','deagle','fiveseven','elite','m3','xm1014','tmp','mac10','mp5navy','ump45','p90','famas','galil','ak47','scout','m4a1','sg550','g3sg1','awp','sg552','aug','m249')
names = ['None',scfg.levels[1]['name'],scfg.levels[2]['name'],scfg.levels[3]['name']]
spawns = {2:[],3:[]}
    
i = {}

#
# BANK INTEGRATION
#
bank_interfaces = map(lambda x: x.basename()[:-3],interfacedir.files('*.py'))
bank = None
if scfg.bank in bank_interfaces:
    bankmodule = __import__('life_insurance.bank_interfaces.%s' % scfg.bank, fromlist=['bank_interfaces', scfg.bank])
    if callable(getattr(bankmodule,'Bank',None)):
        bank = bankmodule.Bank()
if not bank:
    es.dbgmsg(0,'No bank chosen!')
        

class TheInsurance(object):
    def __init__(self,userid):
        self.userid = userid
        self.isvalid = False
        if es.exists('userid', userid):
            self.player = playerlib.getPlayer(userid)
            self.steamid = es.getplayersteamid(userid)
            self.credits = {}
            self.items = []
            if not self.steamid in database:
                self.create()
            else:
                self.get()
            self.thisround = 0
            self.thisroundlvl = 'None'
            self.thisroundlevel = 0
            levels = self.credits.keys()
            levels.reverse()
            for level in levels:
                if self.credits[level]:
                    self.thisround = scfg.levels[level]['respawns']
                    self.thisroundlvl = names[level]
                    break
            self.isvalid = True
            
    def create(self):
        self.credits = {1:0,2:0,3:0,0:0}
        database.create(self.steamid)
        
    def get(self):
        self.credits[1] = database.sel(self.steamid,'credit_basic')
        self.credits[2] = database.sel(self.steamid,'credit_plus')
        self.credits[3] = database.sel(self.steamid,'credit_premium')
        self.credits[0] = 0
    
    def getCredits(self):
        levels = self.credits.keys()
        levels.reverse()
        for level in levels:
            if self.credits[level]:
                return self.credits[level]
        return None
    
    def getLevel(self):
        levels = self.credits.keys()
        levels.reverse()
        for level in levels:
            if self.credits[level]:
                return level
        return 0
    
    def getName(self):
        return names[self.getLevel()]
    
    def minus(self,level):
        database.dec(self.steamid,'credit_%s' % self.getName().lower())
        self.credits[level] -= 1
        
    def buy(self,amount,level,cost):
        self.credits[level] += amount
        database.inc(self.steamid,'credit_%s' % names[level].lower(),amount)
        bank.pay(self.userid,cost)
        database.upd(self.steamid,'lastbuy',amount*10+level)
        self.tell('thank you',{'amount':amount,'packagename':names[level]})
        
    def newround(self):
        if self.userid in es.getUseridList():
            self.items = []
            level = self.getLevel()
            self.thisroundlevel = level
            if not level:
                self.thisround = 0
                self.thisroundlvl = names[0]
                return
            credits = self.getCredits()
            self.minus(level)
            self.thisround = scfg.levels[level]['respawns']
            self.thisroundlvl = names[level]
            self.tell('fee charged1')
            self.tell('fee charged2',{'credits':(credits - 1),'suffix':text('suffix') if (credits - 1) > 1 else '','packagename':self.thisroundlvl})
        
    def death(self):
        if self.getLevel():
            if self.thisround:
                self.respawn()
                
    def respawn(self):
        self.tell('revived')
        self.thisround -= 1
        ESTspawn(self.userid)
        self.player.set('health',scfg.levels[self.getLevel()]['health'])
        if scfg.levels[self.thisroundlevel]['get_weapons']:
            self.giveItems()
            
    def giveItems(self):
        for item in self.items:
            self.give('weapon_%s' % item)
            
    def give(self,item):
        es.server.cmd('es_give %s %s' % (self.userid,item))
        
    def tell(self,message,tokens):
        es.tell(self.userid,'#multi',text(message,tokens))
        
class TheDatabase(object):
    def __init__(self):
        self.con = sqlite3.connect(gamedir.joinpath('addons/eventscripts/life_insurance/insurances.db'))
        self.cur = self.con.cursor()
        self.exe('CREATE TABLE IF NOT EXISTS insurances (steamid TEXT NOT NULL PRIMARY KEY, credit_basic INTEGER, credit_plus INTEGER, credit_premium INTEGER, lastbuy INTEGER DEFAULT 0)',True)
        
    def save(self):
        self.con.commit()
        
    def exe(self,sql,save=False):
        self.cur.execute(sql)
        if save:
            self.save()
        
    def upd(self,steamid,col,new):
        self.exe("UPDATE insurances SET %s=%s WHERE steamid='%s'" % (col,new,steamid),True)
        
    def sel(self,steamid,col):
        self.exe("SELECT %s FROM insurances WHERE steamid='%s'" % (col,steamid))
        return self.cur.fetchone()[0]
        
    def inc(self,steamid,col,amount):
        self.upd(steamid,col,self.sel(steamid,col) + amount)
        
    def dec(self,steamid,col):
        self.upd(steamid,col,self.sel(steamid,col) - 1)
        
    def create(self,steamid):
        self.exe("INSERT INTO insurances (steamid,credit_basic,credit_plus,credit_premium) VALUES ('%s',0,0,0)" % steamid,True)
        
    def __contains__(self,steamid):
        self.exe("SELECT * FROM insurances WHERE steamid='%s'" % steamid)
        return bool(self.cur.fetchone())
    
database = TheDatabase()

def ESTspawn(userid):
    es.server.cmd('est_spawn %s' % userid)
    
def player_spawn(ev):
    userid = ev['userid']
    if not es.getplayersteamid(userid) in database:
        popuplib.send('insurance_welcome',userid) 
    if not userid in i and not es.isbot(userid):
        i[userid] = TheInsurance(int(userid))
        if not i[userid].isvalid:
            del i[userid]
        
def item_pickup(ev):
    if not es.isbot(ev['userid']):
        if ev['item'] in allguns:
            i[ev['userid']].items.append(ev['item'])
    
def player_death(ev):
    teams = {'2':'#t','3':'#ct'}
    if ev['userid'] in i and len(playerlib.getPlayerList('%s,#alive' % teams[ev['es_userteam']])):
        i[ev['userid']].death()
    
def round_end(ev):
    dcfg.sync()
    for userid in playerlib.getUseridList('#human'):
        i[str(userid)].newround()
    
def menus():
    m = popuplib.create('insurance_package_compare')
    m.addline(text('packagecompare'))
    current = scfg.levels[1]
    m.addline(current['name'])
    m.addline(text('respawns',{'amount':current['respawns']}))
    m.addline(text('health',{'amount':current['health']}))
    m.addline(text('get weapon',{'amount':text('yes') if current['get_weapons'] else text('no')}))
    m.addline(text('cost',{'amount':current['cost']}))
    current = scfg.levels[2]
    m.addline(current['name'])
    m.addline(text('respawns',{'amount':current['respawns']}))
    m.addline(text('health',{'amount':current['health']}))
    m.addline(text('get weapon',{'amount':text('yes') if current['get_weapons'] else text('no')}))
    m.addline(text('cost',{'amount':current['cost']}))
    current = scfg.levels[3]
    m.addline(current['name'])
    m.addline(text('respawns',{'amount':current['respawns']}))
    m.addline(text('health',{'amount':current['health']}))
    m.addline(text('get weapon',{'amount':text('yes') if current['get_weapons'] else text('no')}))
    m.addline(text('cost',{'amount':current['cost']}))
    m.addline("->1: %s" % text('back'))
    m.select(1,backproxy)
    
    n = popuplib.create('insurance_about_ojii')
    n.addline(text('about'))
    n.addline("-----------------------------")
    n.addline(" ")
    n.addline(text('about version',{'version':info.version}))
    n.addline(" ")
    n.addline(text('this addon'))
    n.addline(" ")
    n.addline(text('get addon'))
    n.addline("http://addons.eventscripts.com/addons/view/builder")
    n.addline(" ")
    n.addline("->1: %s" % text('back'))
    n.select(1,backproxy)
    
    o = popuplib.create('insurance_pre_buy')
    o.addline(text('choose package'))
    o.addline("--------------------------------------")
    o.addline("->1: %s (%s$ %s)" % (scfg.levels[1]['name'],scfg.levels[1]['cost'],text('each')))
    o.addline("->2: %s (%s$ %s)" % (scfg.levels[2]['name'],scfg.levels[2]['cost'],text('each')))
    o.addline("->3: %s (%s$ %s)" % (scfg.levels[3]['name'],scfg.levels[3]['cost'],text('each')))
    o.select(1,buyCredits1)
    o.select(2,buyCredits2)
    o.select(3,buyCredits3)
    
    p = popuplib.create('insurance_welcome')
    p.addline(text('welcome'))
    p.addline("-------------------------------")
    p.addline(text('this server'))
    p.addline(text('how to use'))
    p.addline(text('feature'))
    p.addline(text('have fun'))
    
    q = popuplib.create('insurance_help')
    q.addline(text('help'))
    q.addline("----------------------------")
    for x in (1,2,3,4,5,6,7,8,9):
        q.addline(text('help %s' % x))
    q.addline("->1: %s" % text('back'))
    q.select(1,backproxy)
    
def backproxy(u,c,p):
    mainmenu(str(u))
        
def player_disconnect(ev):
    userid = ev['userid']
    try:
        active = popuplib.active(int(userid))
        if active:
            active['object'].delete()
    except:
        pass
    if userid in i:
        del i[userid]
    
def insurance_cmd():
    userid = str(es.getcmduserid())
    mainmenu(userid)

def mainmenu(userid):
    iuserid = int(userid)
    level = i[userid].getLevel()
    active = popuplib.active(iuserid)
    if 'name' in active and active['name'] == 'insurance_menu_%s' % userid:
        active['object'].unsend(iuserid)
        return
    lastbuy = database.sel(es.getplayersteamid(userid),'lastbuy')
    level = 'No'
    amount = ''
    cost = 0
    if lastbuy:
        level,amount = convertQuickbuy(lastbuy)
        cost = scfg.levels[level]['cost']*amount if not amount in scfg.multipacks else scfg.levels[level]['cost']*amount*(1-scfg.multipacks[amount])
    quickbuycheck = bank.getBalance(userid) >= cost
    if popuplib.exists('insurance_menu_%s' % userid):
        popuplib.delete('insurance_menu_%s' % userid)
    menu = popuplib.create('insurance_menu_%s' % userid)
    menu.addline(text('main'))
    menu.addline("---------------------")
    menu.addline(text('welcome main',{'playername':es.getplayername(iuserid)}))
    if i[userid].thisround:
        menu.addline(text('you are insured',{'packagename':i[userid].thisroundlvl}))
    else:
        menu.addline(text('not insured'))
    menu.addline(text('your credits'))
    menu.addline("%s    %s: %s" % ('->' if level == 1 else '',scfg.levels[1]['name'],i[userid].credits[1]))
    menu.addline("%s    %s: %s" % ('->' if level == 2 else '',scfg.levels[2]['name'],i[userid].credits[2]))
    menu.addline("%s    %s: %s" % ('->' if level == 3 else '',scfg.levels[3]['name'],i[userid].credits[3]))
    menu.addline(text('quickbuy option',{'arrow':"->" if quickbuycheck else '','amount':amount,'packagename':names[level],'cost':cost}))
    menu.addline(text('buy credits option'))
    menu.addline(text('compare packages option'))
    menu.addline(text('help option'))
    menu.addline(text('about option'))
    menu.addline("->6: %s" % text('exit'))
    menu.select(1,quickbuy)
    menu.submenu(2,'insurance_pre_buy')
    menu.submenu(3,'insurance_package_compare')
    menu.submenu(4,'insurance_help')
    menu.submenu(5,'insurance_about_ojii')
    menu.send(iuserid)    
    
def convertQuickbuy(lastbuy):
    lastbuy = str(lastbuy)
    amount = int(lastbuy[:-1])
    level = int(lastbuy[-1])
    return level,amount

def quickbuyproxy():
    quickbuy(es.getcmduserid(),None,None)
    
def quickbuy(userid,c,p):
    steamid = es.getplayersteamid(userid)
    level,amount = convertQuickbuy(database.sel(steamid,'lastbuy'))
    cost = scfg.levels[level]['cost']*amount if not amount in scfg.multipacks else scfg.levels[level]['cost']*amount*(1-scfg.multipacks[amount])
    if cost >= bank.getBalance(userid):
        es.tell(userid,text('no cash tell'))
    else:
        i[str(userid)].buy(amount,level,cost)
    
def buyCredits1(userid,choice,popupid):
    buyCredits(userid,1)
    
def buyCredits2(userid,choice,popupid):
    buyCredits(userid,2)
    
def buyCredits3(userid,choice,popupid):
    buyCredits(userid,3)
    
def buyCredits(userid,level):
    cash = bank.getBalance(userid)
    cost = scfg.levels[level]['cost']
    if cash <= cost:
        buymenu = popuplib.create('insurance_buy_menu_%s' % userid)
        buymenu.addline(text('buy credits'))
        buymenu.addline("-----------------------------------")
        buymenu.addline(text('cannot afford'))
        buymenu.addline(text('cheaper package'))
        buymenu.addline('->1: %s' % text('back'))
        buymenu.addline('->2: %s' % text('exit'))
        buymenu.submenu(1,'insurance_pre_buy')
    else:
        buymenu = popuplib.easymenu('insurance_buy_menu_%s' % userid,'_popup_choice',buyCreditsCallback)
        buymenu.settitle("%s\n-----------------------------------" % text('buy credits'))
        current = 0
        for x in (1,2,3,4,5):
            current = cost * x
            if current <= cash:                
                buymenu.addoption((x,level,x*cost),text('buy x for y',{'amount':x,'cost':'%s$' % x*cost}))
        if current <= cash:
            for offer in scfg.multipacks:
                current = (1-scfg.multipacks[offer]) * cost * offer
                if current >= cash:
                    break
                buymenu.addoption((offer,level,current),text('buy special',{'amount':offer,'cost':'%s$' % current,'percentage':scfg.multipacks[offer] * 10}))
        buymenu.addoption('back','Back')
    buymenu.send(userid)
        
def buyCreditsCallback(userid,choice,popupid):
    steamid = es.getplayersteamid(userid)
    suserid = str(userid)
    if choice == 'back':
        popuplib.send('insurance_pre_buy',userid)
        return
    amount, level, cost = choice
    i[suserid].buy(amount,level,cost)
    
    
def load():
    es.regsaycmd('!insurance','life_insurance/insurance_cmd')
    es.regclientcmd('insurance_quickbuy','life_insurance/quickbuyproxy')
    for userid in playerlib.getUseridList('#human'):
        i[str(userid)] = TheInsurance(userid)
    menus()
    
def unload():
    es.server.queuecmd('est_unregeventblock player_death life_insurance_pre_death')
    
class dyncfg(dict):
    def __init__(self,f,cvar_prefix='',default={}):
        self.__filepath__ = path.path(f)
        self.__filepath__.touch()
        self.__cvarprefix__ = cvar_prefix
        self.__d__ = {}
        self.__cvars__ = []
        self.sync()
        if default:
            for key in filter(lambda x: not self.__contains__(x),default.keys()):
                self[key] = default[key]

    def __getitem__(self,s):
        s = str(s)
        if s in self.__d__:
            return self.__d__[s]
        L = self.__filepath__.lines(retain=False)
        for line in L:
            if not line.startswith('#'):
                var,val = line.split('=',1)
                var = var.strip()
                val = val.strip()
                if var == s:
                    self.__d__[var] = val
                    self.__cvars__.append(self.__cvarprefix__ + var)
                    return val
        return None
    
    def __contains__(self,s):
        if s in self.__d__:
            return True
        L = self.__filepath__.lines(retain=False)
        for line in L:
            if line.startswith(s):
                return True
        return False

    def __setitem__(self,s,v):
        s = str(s)
        v = str(v)
        self.__d__[s] = v
        self.__cvars__.append(self.__cvarprefix__ + s)
        L = self.__filepath__.lines(retain=False)
        done = False
        for line in L:
            if not line.startswith('#') and line.count('=') != 0:
                if line.startswith(s):
                    L[L.index(line)] = '%s = %s' % (s,v)
                    done = True
                    break
        if not done:
            L.append('%s = %s' % (s,v))
        self.__filepath__.write_lines(L)
        self.serverVar(s,v)
        
    def serverVar(self,s,v):
        es.ServerVar(self.__cvarprefix__ + s,v).addFlag('notify')

    def sync(self):
        self.__d__ = {}
        self.__cvars__ = []
        L = self.__filepath__.lines(retain=False)
        for line in L:
            if not line.startswith('#') and line.count('=') != 0:
                var,val = line.split('=')
                var = var.strip()
                val = val.strip()
                self.__d__[var] = val
                self.serverVar(var,val)
                self.__cvars__.append(self.__cvarprefix__ + var)
        self.__filepath__.write_lines(L)
                
    def keys(self):
        return self.__d__.keys()
        
    def cvars(self):
        return self.__cvars__
    
    def cvarchange(self,var,val):
        var = var[len(self.__cvarprefix__):]
        self[var] = val
   
def server_cvar(ev):
    if ev['cvarname'] in dcfg.cvars():
        dcfg.cvarchange(ev['cvarname'],ev['cvarvalue'])
    
default = {'welcome_message':'1','language':'en'}
dcfg = dyncfg(gamedir.joinpath('cfg/chatlog.cfg'),'li_',default)

def text(name,tokens={}):
    return ttext(name,tokens,dcfg['language'])
ttext = langlib.Strings(gamedir.joinpath('addons/eventscripts/life_insurance/languages.ini')) 